#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <limits.h>
#include "heyawari.h"

int SearchName(char *name);

int SearchName(char *name)
    {
    int i;
    for(i=0;i<MemberN;++i)
        {
        if(strcmp(Member[i],name)==0)
            {
            return i;
            }
        }
    for(i=0;i<RoomN;++i)
        {
        if(strcmp(Room[i].name,name)==0)
            {
            return MemberN+i;
            }
        }
    return -1;
    }

/*****************************************************************************/






#define GETCHAR \
    if(fscanf(fp,"%1s",string)!=1)ERROR \
    else NULL

#define IF(c) \
    if(strcmp(string,c)==0)

#define UNLESS(c) \
    if(strcmp(string,c)!=0)

#define ERROR  \
        {  \
        fprintf(stderr,"Error : (file %s,line %d)\n",__FILE__,__LINE__);   \
        return -1;                                                       \
        }


#define GETALNUM \
    if(fscanf(fp,AlNum,string)!=1)ERROR \
    else NULL






/*****************************************************************************/


int Cmd_member(FILE *fp)
    {
    char string[MaxLength];
    if(Mode!=MODE_Member)
        {
        fprintf(stderr,"Error : \"member\" after \"memberOK\"\n");
        return -1;
        }
    GETCHAR;UNLESS("{")ERROR;
    for(;;)
        {/* FilePointer  O̐擪 */
        GETALNUM;
        if(SearchName(string)>=0)
            {
            printf("Error : O \"%s\" ͊ɓo^Ă܂B\n",string);
            return -1;
            }
        Member=(char **)realloc(Member,sizeof(char *)*(MemberN+1));
        Member[MemberN]=strdup(string);
        ++MemberN;
        GETCHAR;
        IF("}")break;
        UNLESS(",")ERROR;
        }
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }


/*****************************************************************************/

int Cmd_end(FILE *fp)
    {
    char string[MaxLength];
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }


/*****************************************************************************/


int Cmd_srand(FILE *fp)
    {
    char string[MaxLength];
    unsigned int seed;
    GETCHAR;UNLESS("{")ERROR;
    if(fscanf(fp,"%u",&seed)!=1)ERROR;
    GETCHAR;UNLESS("}")ERROR;
    GETCHAR;UNLESS(";")ERROR;
    srand(seed);
    return 0;
    }


/*****************************************************************************/

#define UnReg (-1)
#define RoomX (-2)

int Cmd_heyawari(FILE *fp)
    {
    char string[MaxLength];

    int i,n,capa;
    int ThisRoom;
    int roomn;

    free(Heyawari);

    Heyawari=(int *)malloc(sizeof(*Heyawari)*(MemberN));
    for(i=0;i<MemberN+RoomN;++i)Heyawari[i]=UnReg;

    if(Mode!=MODE_Group)
        {
        fprintf(stderr,"Error : \"heyawari\" after \"memberOK\"\n");
        return -1;
        }

    GETCHAR;UNLESS("{")ERROR;

    for(roomn=0;;++roomn)
        {
        ThisRoom=RoomX;
        capa=0;
        GETCHAR;UNLESS("{")ERROR;
        for(;;)
            {
            GETALNUM;
            n=SearchName(string);
            if(n<0)
                {
                fprintf(stderr,"o^ĂȂO \"%s\" w肳܂B\n",string);
                return -1;
                }
            if(n>=MemberN)
                {
                if(ThisRoom>=0)
                    {
                    fprintf(stderr,"Error : O[vŕQw肳܂B\n");
                    return -1;
                    }
                ThisRoom=n-MemberN;
                for(i=0;i<MemberN;++i)
                    {
                    if(Heyawari[i]==ThisRoom)
                        {
                        fprintf(stderr,"Error :  \"%s\" Q̃O[vŎw肳܂B\n",Room[ThisRoom].name);
                        return -1;
                        }
                    }
                for(i=0;i<MemberN;++i)
                    {
                    if(Heyawari[i]==RoomX)Heyawari[i]=ThisRoom;
                    }
                }
            else
                {
                if(Heyawari[n]>=0)
                    {
                    fprintf(stderr,"Error : \"%s\" Qxw肳܂B\n",string);
                    return -1;
                    }
                ++capa;
                Heyawari[n]=ThisRoom;
                }
            GETCHAR;
            IF("}")break;
            UNLESS(",")ERROR;
            }
        if(ThisRoom<RoomX)
            {
            fprintf(stderr,"Error : O[vɕ̎w肪܂B\n",string);
            return -1;
            }
        if(Room[ThisRoom].capa!=capa)
            {
            fprintf(stderr,"Error :  \"%s\" ̐lsłB\n",Room[ThisRoom].name);
            return -1;
            }

        GETCHAR;
        IF("}")break;
        UNLESS(",")ERROR;
        }
    GETCHAR;UNLESS(";")ERROR;

    if(roomn<RoomN-1)
        {
        fprintf(stderr,"Error : w肳ĂȂL܂B\n");
        return -1;
        }
    return 0;
    }

#undef UnReg
#undef RoomX

/*****************************************************************************/

int Cmd_autoheyawari(FILE *fp)
    {
    char string[MaxLength];
    int n;
    if(Mode!=MODE_Group)
        {
        fprintf(stderr,"Error : \"autoheyawari\" before \"memberOK\"\n");
        return -1;
        }
    n=0;
    GETCHAR;IF("{")
        {
        if(fscanf(fp,"%d",&n)!=1)ERROR;
        GETCHAR;UNLESS("}")ERROR;
        GETCHAR;
        }
    UNLESS(";")ERROR;
    if((n<0)||(n>1))
        {
        fprintf(stderr,"Error : `ĂȂ葱ԍw肳܂B\n");
        return -1;
        }
    free(Heyawari);
    switch(n)
        {
        case 0:
            {
            long goodness,goodnessNEW;
            int *heyawariNEW;
            Heyawari=NULL;
            goodness=LONG_MIN;
            /********************************/
            heyawariNEW=Saitekika();
            goodnessNEW=Tensuu(heyawariNEW);
            if(goodnessNEW>goodness)
                {
                free(Heyawari);
                Heyawari=heyawariNEW;
                goodness=goodnessNEW;
                }
            else
                {
                free(heyawariNEW);
                }
            /********************************/
            break;
            }
        case 1:Heyawari=Saitekika();
        }
    return 0;
    }


/*****************************************************************************/
    /* ˑȂ߂̕׊ */
int Cmd_shuffle(FILE *fp)
    {
    char string[MaxLength];
    int i;
    int r;
    char **MemberNEW;
    room_t *RoomNEW;

    if(Mode!=MODE_Member)
        {
        fprintf(stderr,"Error : \"shuffle\" after \"memberOK\"\n");
        return -1;
        }
    GETCHAR;UNLESS(";")ERROR;


    MemberNEW=(char **)malloc(sizeof(char *)*MemberN);
    for(i=0;i<MemberN;++i)
        {
        do  {
            r=rand()%MemberN;
            }while(Member[r]==NULL);
        MemberNEW[i]=Member[r];
        Member[r]=NULL;
        }
    free(Member);
    Member=MemberNEW;

    RoomNEW=(room_t *)malloc(sizeof(room_t)*RoomN);
    for(i=0;i<RoomN;++i)
        {
        do  {
            r=rand()%RoomN;
            }while(Room[r].name==NULL);
        RoomNEW[i]=Room[r];
        Room[r].name=NULL;
        }
    free(Room);
    Room=RoomNEW;
    return 0;
    }


/*****************************************************************************/

int Cmd_memberOK(FILE *fp)
    {
    int i,capasum;
    char string[MaxLength];
    GETCHAR;UNLESS(";")ERROR;
    if(Mode!=MODE_Member)
        {
        fprintf(stderr,"Error : double \"memberOK\"\n");
        return -1;
        }




    Goodness=(long *)malloc(sizeof(*Goodness)*MemberN*(MemberN+RoomN));
    for(i=0;i<MemberN*(MemberN+RoomN);++i)
        {
        Goodness[i]=0L;
        }
    Mode=MODE_Group;

    capasum=0;
    for(i=0;i<RoomN;++i)capasum+=Room[i].capa;
    if(capasum!=MemberN)
        {
        fprintf(stderr,"Error : el̍v (%d) Ao[̐ (%d) ƈv܂\n",capasum,MemberN);
        return -1;        
        }
    if(MemberN==0)
        {
        fprintf(stderr,"Error : o^Ă܂B\n");
        return -1;
        }
    return 0;
    }

/*****************************************************************************/

int Cmd_comment(FILE *fp)
    {
    char string[MaxLength];
    GETCHAR;UNLESS("{")ERROR;
    if(fscanf(fp,"%*[^}]")!=0)ERROR;
    GETCHAR;UNLESS("}")ERROR;
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }


/*****************************************************************************/

int Cmd_print(FILE *fp)
    {
    char string[MaxLength];
    GETCHAR;UNLESS("{")ERROR;
    switch(fscanf(fp,"%[^}]",string))
        {
        case 0:printf("\n");break;
        case 1:printf("%s\n",string);break;
        default:ERROR;
        }
    GETCHAR;UNLESS("}")ERROR;
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }

/*****************************************************************************/


void OutputMember(FILE *fp)
    {
    int i;
    fprintf(fp,"***[ Members ]***\n");
    if(MemberN==0)
        {
        fprintf(fp,"܂lo^Ă܂\n");
        return;
        }
    for(i=0;i<MemberN;++i)fprintf(fp,"%3d:%s\n",i+1,Member[i]);
    }
void OutputRoom(FILE *fp)
    {
    int i;
    fprintf(fp,"***[ Rooms ]***\n");
    if(RoomN==0)
        {
        fprintf(fp,"܂o^Ă܂\n");
        return;
        }
    for(i=0;i<RoomN;++i)fprintf(fp,"%3d:%5s[%2d]\n",i+1,Room[i].name,Room[i].capa);
    }
void OutputGoodness(FILE *fp)
    {
    int i,j;
    fprintf(fp,"***[ Goodness-Table ]***\n");
    if(Goodness==NULL)
        {
        fprintf(fp,"Goodness e[u͂܂L܂B\n");
        return;
        }
    fprintf(fp,"%11s","");
    for(i=0;i<MemberN;++i)
        {
        fprintf(fp,"%8s",Member[i]);
        }
    fprintf(fp,"\n");
    for(i=0;i<MemberN+RoomN;++i)
        {
        if(i==MemberN)fprintf(fp,"\n");
        if(i<MemberN)fprintf(fp,"%-8s : ",Member[i]);
        else         fprintf(fp,"%-8s : ",Room[i-MemberN].name);
        for(j=0;j<MemberN;++j)
            {
            fprintf(fp,"%8ld",GOODNESS(i,j));
            }
        fprintf(fp,"\n");
        }
    }

void OutputHeyawari(FILE *fp)
    {
    int r,m;
    fprintf(fp,"[ RESULT ]\n");
    if(Heyawari==NULL)
        {
        fprintf(fp,"͂܂ȂĂ܂B\n");
        return;
        }
    fprintf(fp,"Goodness : %ld\n\n",Tensuu(Heyawari));
    for(r=0;r<RoomN;++r)
        {
        fprintf(fp,"%-10s : ",Room[r].name);
        for(m=0;m<MemberN;++m)
            {
            if(Heyawari[m]==r)fprintf(fp,"%-10s",Member[m]);
            }
        fprintf(fp,"\n");
        }
        fprintf(fp,"\n");
    }




void LaTeX_Heyawari(FILE *fp)
    {
    int maxcapa;
    int i,j;

    if(Heyawari==NULL)
        {
        fprintf(fp,"͂܂ȂĂ܂B\n");
        return;
        }

    maxcapa=0;
    for(i=0;i<RoomN;++i)
        {
        if(Room[i].capa>maxcapa)maxcapa=Room[i].capa;
        }
    fprintf(fp,"\\documentstyle[a4]{article}\n");
    fprintf(fp,"\\begin{document}\n");

    fprintf(fp,"\\large\n");
    fprintf(fp,"\\begin{tabular}{|l|");
    for(i=0;i<maxcapa;++i)fprintf(fp,"l");
    fprintf(fp,"|}\n");

    fprintf(fp,"\\hline\n");

    fprintf(fp,"\\em Room & \\makebox[0em][l]{\\em Member} ");
    for(i=1;i<maxcapa;++i)
        {
        fprintf(fp,"&");
        }
    fprintf(fp,"\\\\\n");
    fprintf(fp,"\\hline\n");
    fprintf(fp,"\\hline\n");

    for(i=0;i<RoomN;++i)
        {
        int capa;
        fprintf(fp,"%s ",Room[i].name);
        capa=0;
        for(j=0;j<MemberN;++j)
            {
            if(Heyawari[j]==i)
                {
                fprintf(fp,"& %s ",Member[j]);
                ++capa;
                }
            }
        for(j=capa;j<maxcapa;++j)
                fprintf(fp,"&");
                fprintf(fp,"\\\\\n");
        fprintf(fp,"\\hline\n");
        }

    fprintf(fp,"\\end{tabular}\n");
    fprintf(fp,"\\end{document}\n");
    return;
    }



int Cmd_output(FILE *fp)
    {
    char string[MaxLength];
    char object[MaxLength];

    FILE *File;/* o͐̃t@C */

    GETCHAR;UNLESS("{")ERROR;
    for(;;)
        {
        if(fscanf(fp,AlNum,object)!=1)ERROR;
        GETCHAR;
        IF(">")
	    {
            if(fscanf(fp," %[^ {},\n\t]",string)!=1)ERROR;
            File=fopen(string,"w");
            if(File==NULL)
                {
                fprintf(stderr,"t@C \"%s\" I[vł܂łB\n",string);
                }
            GETCHAR;
            }
        else
            {
            File=stdout;
            }

        if     (strcmp(object,"member"  )==0)OutputMember(File);
        else if(strcmp(object,"room"    )==0)OutputRoom(File);
        else if(strcmp(object,"goodness")==0)OutputGoodness(File);
        else if(strcmp(object,"heyawari")==0)OutputHeyawari(File);
        else if(strcmp(object,"LaTeXheyawari")==0)LaTeX_Heyawari(File);
        else
            {
            fprintf(stderr,"Error : `ĂȂ object \"%s\" w肳܂B\n",object);
            return -1;
            }
        if(File!=stdout)fclose(File);


        IF("}")break;
        UNLESS(",")ERROR;
        }
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }
/*****************************************************************************/

int Cmd_trace(FILE *fp)
    {
    char string[MaxLength];
    GETCHAR;UNLESS("{")ERROR;
    GETALNUM;
    if     (strcmp(string,"on" )==0)TraceMode=TRACE_ON;
    else if(strcmp(string,"off")==0)TraceMode=TRACE_OFF;
    else
        {
        fprintf(stderr,"Error : `ĂȂ \"%s\" w肳܂B\n",string);
        return -1;
        }
    GETCHAR;UNLESS("}")ERROR;
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }


/*****************************************************************************/

int Cmd_room(FILE *fp)
    {
    char string[MaxLength];
    if(Mode!=MODE_Member)
        {
        fprintf(stderr,"Error : \"room\" after \"memberOK\"\n");
        return -1;
        }
    GETCHAR;UNLESS("{")ERROR;
    for(;;)
        {/* FilePointer  {,} ̐擪 */
        int capa;
        char name[MaxLength];

        GETCHAR;UNLESS("{")ERROR;
        if(fscanf(fp,AlNum,name)!=1)ERROR;
        if(SearchName(name)>=0)
            {
            printf("Error : O \"%s\" ͊ɓo^Ă܂B\n",name);
            return -1;
            }
        GETCHAR;UNLESS(",")ERROR;

        if(fscanf(fp,"%d",&capa)!=1)ERROR;

        GETCHAR;UNLESS("}")ERROR;

        Room=(room_t *)realloc(Room,sizeof(*Room)*(RoomN+1));
        Room[RoomN].name=strdup(name);
        Room[RoomN].capa=capa;
        ++RoomN;
        GETCHAR;
        IF("}")break;
        UNLESS(",")ERROR;
        }
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }
/*****************************************************************************/


int Cmd_random(FILE *fp)
    {
    char string[MaxLength];
    GETCHAR;UNLESS("{")ERROR;
    if(fscanf(fp,"%d",&Iteration)!=1)ERROR;
    GETCHAR;UNLESS(",")ERROR;
    if(fscanf(fp,"%d",&Exchange)!=1)ERROR;
    GETCHAR;UNLESS("}")ERROR;
    GETCHAR;UNLESS(";")ERROR;
    return 0;
    }






/*****************************************************************************/

#undef ERROR

#define ERROR  \
        {  \
        free(frag); \
        fprintf(stderr,"Error : (file %s,line %d)\n",__FILE__,__LINE__);   \
        return -1;                                                       \
        } \

/*****************************************************************************/



#define UnReg  0
#define Head   1
#define Other  2

int Cmd_goodness(FILE *fp)
    {
    char string[MaxLength];

    int *frag;
    int i,n,g;
    int head;

    frag=(int *)malloc(sizeof(*frag)*(MemberN+RoomN));
    for(i=0;i<MemberN+RoomN;++i)frag[i]=UnReg;


    if(Mode!=MODE_Group)
        {
        fprintf(stderr,"Error : goodness before memberOK\n");
        return -1;
        }
    GETCHAR;UNLESS("{")ERROR;


    GETALNUM;
    if(strcmp(string,"")==0)
        {
        fprintf(stderr,"G[łB\n");
        free(frag);
        return -1;
        }

    head=SearchName(string);
    if(head<0)
        {
        fprintf(stderr,"o^ĂȂO \"%s\" w肳܂B\n",string);
        free(frag);
        return -1;
        }
    frag[head]=Head;
    GETCHAR;UNLESS(",")ERROR;
    if(fscanf(fp,"%d",&g)!=1)ERROR;
    if((g<-10000)||(g>10000))
        {
        fprintf(stderr,"Error : goodness must be -10000~10000\n");
        free(frag);
        return -1;
        }

    GETCHAR;UNLESS(",")ERROR;
    GETCHAR;UNLESS("{")ERROR;

    for(;;)
        {/* FilePointer  O̐擪 */
        GETALNUM;
        if(strcmp(string,"")==0)
            {
            fprintf(stderr,"G[łB\n");
            free(frag);
            return -1;
            }
        n=SearchName(string);
        if(n<0)
            {
            fprintf(stderr,"o^ĂȂO \"%s\" w肳܂B\n",string);
            free(frag);
            return -1;
            }
        if(frag[n]!=UnReg)
            {
            fprintf(stderr,"Error : O \"%s\" Qxw肳܂B\n",string);
            free(frag);
            return -1;
            }
        if((head>=MemberN)&&(n>=MemberN))
            {
            fprintf(stderr,"Error : ̊Ԃ̃p[^͎wł܂B\n",string);
            free(frag);
            return -1;
            }

        frag[n]=Other;

        GETCHAR;
        IF("}")break;
        UNLESS(",")ERROR;
        }

    GETCHAR;UNLESS("}")ERROR;
    GETCHAR;UNLESS(";")ERROR;

    for(i=0;i<MemberN+RoomN;++i)
        {
        if(frag[i]==Other)
            {
            if(i   <MemberN)GOODNESS(head,i)+=g;
            if(head<MemberN)GOODNESS(i,head)+=g;
            }
        }
    free(frag);

    return 0;
    }
#undef UnReg
#undef Head
#undef Other


/*****************************************************************************/



int Cmd_group(FILE *fp)
    {
    char string[MaxLength];

    int *frag;
    int i,j,n,sameG,otherG;
    int GroupNumber;

    frag=(int *)malloc(sizeof(*frag)*(MemberN+RoomN));
    for(i=0;i<MemberN+RoomN;++i)frag[i]= -1;

    if(Mode!=MODE_Group)ERROR;

    GETCHAR;UNLESS("{")ERROR;

    if(fscanf(fp,"%d",&sameG)!=1)ERROR;
    if((sameG<-10000)||(sameG>10000))
        {
        fprintf(stderr,"Error : goodness must be -10000~10000\n");
        free(frag);
        return -1;
        }

    GETCHAR;UNLESS(",")ERROR;

    if(fscanf(fp,"%d",&otherG)!=1)ERROR;
    if((otherG<-10000)||(otherG>10000))
        {
        fprintf(stderr,"Error : goodness must be -10000~10000\n");
        free(frag);
        return -1;
        }

    GETCHAR;UNLESS(",")ERROR;

    for(GroupNumber=0;;++GroupNumber)
        {

        GETCHAR;UNLESS("{")ERROR;
        for(;;)
            {
            GETALNUM;
            n=SearchName(string);
            if(n<0)
                {
                fprintf(stderr,"o^ĂȂO \"%s\" w肳܂B\n",string);
                free(frag);
                return -1;
                }
            if(frag[n]>=0)
                {
                fprintf(stderr,"Error : O \"%s\" Qxw肳܂B\n",string);
                free(frag);
                return -1;
                }

            frag[n]=GroupNumber;

            GETCHAR;
            IF("}")break;
            UNLESS(",")ERROR;
            }
        GETCHAR;
        IF("}")break;
        UNLESS(",")ERROR;
        }
    GETCHAR;UNLESS(";")ERROR;

    for(i=0;i<MemberN+RoomN;++i)
        {
        for(j=0;j<i;++j)
            {
            if((frag[i]<0)||(frag[j]<0))continue;
            if(frag[i]==frag[j])
                {
                GOODNESS(i,j)+=sameG;
                if(i<MemberN)GOODNESS(j,i)+=sameG;
                }
            else
                {
                GOODNESS(i,j)+=otherG;
                if(i<MemberN)GOODNESS(j,i)+=otherG;
                }
            }
        }

    free(frag);
    return 0;
    }

/*****************************************************************************/

#undef ERROR

