#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <limits.h>
#include "heyawari.h"

int    Mode;
int    TraceMode;

char  **Member;
int     MemberN;

room_t *Room;
int     RoomN;

long   *Goodness;

int    *Heyawari;

/* RandomTest */
int Iteration;
int Exchange;


int LoadDataFile(FILE *fp);

int main(int argc,char *argv[])
    {
    int i,ret;
    FILE *fp;

    /*
    fprintf(stderr,"*************************************\n");
    fprintf(stderr,"*  ւ肭   Version 1.0       *\n");
    fprintf(stderr,"*        22 Sep.'95  by Imamura,Y.  *\n");
    fprintf(stderr,"*************************************\n");
    */

    if(argc>2)
        {
        fprintf(stderr,"Error : ߂܂B\n");
        exit(1);
        }
    /******************************************/
    if(argc<2)
        {
        fp=stdin;
        }
    else
        {
        fp=fopen(argv[1],"r");
        if(fp==NULL)
            {
            fprintf(stderr,"t@CI[vł܂B\n");
            exit(1);
            }
        }
    if(LoadDataFile(fp)==0)ret=0;else ret=1;
    if(argc==2)fclose(fp);
    /******************************************/
    for(i=0;i<MemberN;++i)free(Member[i]);
    free(Member);
    for(i=0;i<RoomN;++i)free(Room[i].name);
    free(Room);
    free(Goodness);
    exit(ret);
    }





int LoadDataFile(FILE *fp)
    {
    Mode=MODE_Member;
    Member=NULL;
    MemberN=0;
    Room=NULL;
    RoomN=0;
    Goodness=NULL;
    Heyawari=NULL;
    TraceMode=TRACE_OFF;

    Iteration=0;
    Exchange=0;

    for(;;)
        {
        char string[MaxLength];
        /* ł FilePointer ͍s̐擪ɂ */
        if(fp==stdin)
            {
            if(Mode==MODE_Member)fprintf(stderr,"Reg.>");
            else                 fprintf(stderr,"Par.>");
            }
        if(fscanf(fp,AlNum,string)!=1)
            {
            fprintf(stderr,"Error : (file %s,line %d)\n",__FILE__,__LINE__);
            return -1;
            }
        if(TraceMode==TRACE_ON)fprintf(stderr,"Command : %s\n",string);
        if     (strcmp(string,"comment"     )==0){if(Cmd_comment     (fp)<0)return -1;}
        else if(strcmp(string,"member"      )==0){if(Cmd_member      (fp)<0)return -1;}
        else if(strcmp(string,"memberOK"    )==0){if(Cmd_memberOK    (fp)<0)return -1;}
        else if(strcmp(string,"room"        )==0){if(Cmd_room        (fp)<0)return -1;}
        else if(strcmp(string,"goodness"    )==0){if(Cmd_goodness    (fp)<0)return -1;}
        else if(strcmp(string,"group"       )==0){if(Cmd_group       (fp)<0)return -1;}
        else if(strcmp(string,"random"      )==0){if(Cmd_random      (fp)<0)return -1;}
        else if(strcmp(string,"output"      )==0){if(Cmd_output      (fp)<0)return -1;}
        else if(strcmp(string,"autoheyawari")==0){if(Cmd_autoheyawari(fp)<0)return -1;}
        else if(strcmp(string,"heyawari"    )==0){if(Cmd_heyawari    (fp)<0)return -1;}
        else if(strcmp(string,"trace"       )==0){if(Cmd_trace       (fp)<0)return -1;}
        else if(strcmp(string,"print"       )==0){if(Cmd_print       (fp)<0)return -1;}
        else if(strcmp(string,"srand"       )==0){if(Cmd_srand       (fp)<0)return -1;}
        else if(strcmp(string,"shuffle"     )==0){if(Cmd_shuffle     (fp)<0)return -1;}
        else if(strcmp(string,"end"         )==0){if(Cmd_end         (fp)<0)return -1;else break;}
        else
            {
            fprintf(stderr,"`ĂȂR}h(%s)gp܂B\n",string);
            return -1;
            }
        }
    return 0;
    }

